package ejb30.persistence.datatypes.client;

import ejb30.persistence.datatypes.ejb.DataTypes;
import ejb30.persistence.datatypes.ejb.DataTypesSession;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

import javax.naming.InitialContext;
import javax.ejb.*;
import javax.annotation.*;
import java.util.*;
import java.text.*;

public class Client
{
   private static @EJB DataTypesSession dao;
   private static SimpleReporterAdapter status =
        new SimpleReporterAdapter("appserver-sqe");
   public static void main(String[] args) throws Exception
   {
      String testSuiteID = args[0];
      int firstrowID = 1; 	
      int secondrowID = 2; 	
        String dateString = "";
        java.util.Date utildate = null;
        long long_time = 0;
        java.sql.Date sqldate = null;
	java.sql.Timestamp timestamp = null;
        String time = "";
        Locale currentLocale=new Locale("en","US");
        DateFormat df= DateFormat.getDateInstance(DateFormat.SHORT,
            currentLocale);
      DataTypes firstrow = new DataTypes();
      DataTypes secondrow = new DataTypes();

      status.addDescription(" Testing EJB 3.0 DataTypes ");

     try {
        dateString = "09/15/76";
        utildate = df.parse(dateString);
            /*
             *Setting up of TimeStamp Data"
             **/
            SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
            String date = "09-15-1979 15:52";
            long timeInMillis = sdf.parse (date).getTime ();
            timestamp=new java.sql.Timestamp(timeInMillis);
            timestamp.setNanos(123000);
      	firstrowID = dao.create(1, new Boolean(false),new Byte(Byte.MAX_VALUE),new Character ('a'),new Short(Short.MAX_VALUE),new Integer(1993),new Long(12345),new Float(3.40282E38),new Double(123456789),utildate,new java.sql.Date(utildate.getTime()),timestamp);
      	System.out.println(testSuiteID + "Create_row_MAXVAL: PASS");
	status.addStatus(testSuiteID + "-Create_row_MAXVAL", status.PASS);
     } catch (Exception e) {
        System.out.println(testSuiteID + " Create_row_MAXVAL: FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID+"-Create_row_MAXVAL", status.FAIL);
     }

     firstrow = dao.find(firstrowID);
     if(firstrow.getByteData().equals(new Byte(Byte.MAX_VALUE))){
       status.addStatus(testSuiteID + "-Populate_BYTE_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + "-Populate_BYTE_MAXVAL", status.FAIL);
     if(firstrow.getShortData().equals(new Short(Short.MAX_VALUE))){
       status.addStatus(testSuiteID + "-Populate_SHORT_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + "-Populate_SHORT_MAXVAL", status.FAIL);
     if(firstrow.getLongData().equals(new Long(12345))){
       status.addStatus(testSuiteID + "-Populate_LONG_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + "-Populate_LONG_MAXVAL", status.FAIL);
     if(firstrow.getIntegerData().equals(new Integer(1993))){
       status.addStatus(testSuiteID + "-Populate_INTEGER_MAXVAL", status.PASS);
     } else
       status.addStatus(testSuiteID + "-Populate_INTEGER_MAXVAL", status.FAIL);

     try {
        dateString = "09/10/76";
        utildate = df.parse(dateString);
            timestamp.setNanos(124000);
      	secondrowID = dao.create(2, new Boolean(false),new Byte("101"),new Character ('b'),new Short("1001"),new Integer("1007"),new Long("1002"),new Float("1004"),new Double("2222"),utildate,new java.sql.Date(utildate.getTime()),timestamp);
        System.out.println(testSuiteID + "-Create_row_MEDIANVAL: PASS");
        status.addStatus(testSuiteID + "-Create_row_MEDIANVAL", status.PASS);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Create_row_MEDIANVAL: FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Create_row_MEDIANVAL", status.FAIL);
     }

     try {
        dateString = "09/20/76";
        utildate = df.parse(dateString);
            timestamp.setNanos(125000);
      	int thirdrowID = dao.create(3, new Boolean(false),new Byte("0"),new Character ('c'),new Short("0"),new Integer("0"),new Long("0"),new Float("0"),new Double("0"),utildate,new java.sql.Date(utildate.getTime()),timestamp);
        System.out.println(testSuiteID + "-Create_row_ZEROVAL: PASS");
        status.addStatus(testSuiteID + "-Create_row_ZEROVAL", status.PASS);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Create_row_ZEROVAL: FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Create_row_ZEROVAL", status.FAIL);
     }

     try {
      	secondrow = dao.find(secondrowID);
      	System.out.println("The 2nd row Boolean value is : " + secondrow.getBooleanData());
      	System.out.println("The 2nd row Character value is : " + secondrow.getCharacterData());
        System.out.println(testSuiteID + "-Read_row: PASS");
	status.addStatus(testSuiteID + "-Read_row", status.PASS);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Read_row : FAIL");
        System.out.println("Exception Caught: " + e );
	status.addStatus(testSuiteID + "-Read_row", status.FAIL);
     }

     try {
      	secondrow.setBooleanData(new Boolean(true));
      	System.out.println("The changed Boolean value is : " + secondrow.getBooleanData());
      	System.out.println(testSuiteID + "-Update_row: PASS");
	status.addStatus(testSuiteID + "-Update_row", status.PASS);
     } catch (Exception e) {
      	System.out.println(testSuiteID + "-Update_row: FAIL");
      	System.out.println("Exception Caught: " + e );
	status.addStatus(testSuiteID + "-Update_row", status.FAIL);
     }
      
     try {
      List listLong = dao.whereWithLong(new Long("1002"));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("LongData = " + c.getLongData());
          System.out.println("UtilDateData = " + c.getUtilDateData());
          System.out.println("SQLDateData = " + c.getSqlDateData());
      }
      System.out.println(testSuiteID + "-Query_Long : PASS");
      status.addStatus(testSuiteID + "-Query_Long", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Long : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Long", status.FAIL);
     }

     try {
      List listLong = dao.whereWithShort(new Short("1001"));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("ShortData = " + c.getShortData());
      }
      System.out.println(testSuiteID + "-Query_Short : PASS");
      status.addStatus(testSuiteID + "-Query_Short", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Short : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Short", status.FAIL);
     }

     try {
      List listLong = dao.whereWithFloat(new Float("1004"));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("FloatData = "+ c.getFloatData());
      }
      System.out.println(testSuiteID + "-Query_Float : PASS");
      status.addStatus(testSuiteID + "-Query_Float", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Float : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Float", status.FAIL);
     }

     try {
      List listLong = dao.whereWithInteger(new Integer("1007"));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("IntegerData = " + c.getIntegerData());
      }
      System.out.println(testSuiteID + "-Query_Integer : PASS");
      status.addStatus(testSuiteID + "-Query_Integer", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Integer : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Integer", status.FAIL);
     }

     try {
      List listLong = dao.whereWithCharacter(new Character('b'));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("CharacterData = " + c.getCharacterData());
      }
      System.out.println(testSuiteID + "-Query_Character : PASS");
      status.addStatus(testSuiteID + "-Query_Character", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Character : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Character", status.FAIL);
     }

     try {
      List listLong = dao.whereWithByte(new Byte("101"));
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("ByteData = " + c.getByteData());
      }
      System.out.println(testSuiteID + "-Query_Byte : PASS");
      status.addStatus(testSuiteID + "-Query_Byte", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Byte : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Byte", status.FAIL);
     }

     try {
      List listLong = dao.maxRowSelection(new Integer("1"));
      System.out.println(testSuiteID + "-Query_Row_MAX_Value: PASS");
      status.addStatus(testSuiteID + "-Query_Row_MAX_Value", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_Row_MAX_Value : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_Row_MAX_Value", status.FAIL);
     }

     try {
            dateString = "09/10/76";
            df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
            utildate = df.parse(dateString);
      List listLong = dao.utilDateSelection(utildate);
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("UtilDateData = " + c.getUtilDateData());
      }
      System.out.println(testSuiteID + "-Query_UtilDate : PASS");
      status.addStatus(testSuiteID + "-Query_UtilDate", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query UtilDate : FAIL");
      System.out.println(testSuiteID + "Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_UtilDate", status.FAIL);
     }

     try {
            dateString = "09/10/76";
            df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
            utildate = df.parse(dateString);
      sqldate=new java.sql.Date(utildate.getTime());
      List listLong = dao.sqlDateSelection(sqldate);
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("SqlDateData = " + c.getSqlDateData());
      }
      System.out.println(testSuiteID + "-Query_SqlDate : PASS");
      status.addStatus(testSuiteID + "-Query_SqlDate", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_SqlDate : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_SqlDate", status.FAIL);
     }

     try {
            dateString = "09/10/76";
            df= DateFormat.getDateInstance(DateFormat.SHORT,currentLocale);
            utildate = df.parse(dateString);
            SimpleDateFormat sdf = new SimpleDateFormat ("dd-MM-yyyy HH:mm");
            String date = "09-15-1979 15:52";
            long timeInMillis = sdf.parse (date).getTime ();
            timestamp=new java.sql.Timestamp(timeInMillis);
            timestamp.setNanos(125000);

      List listLong = dao.timeStampSelection(timestamp);
      Iterator iter = listLong.iterator();
      while (iter.hasNext()) {
          DataTypes c = (DataTypes)iter.next();
          System.out.println("TimeStampData = " + c.getTimeStampData());
      }
      System.out.println(testSuiteID + "-Query_TimeStamp : PASS");
      status.addStatus(testSuiteID + "-Query_TimeStamp", status.PASS);
     } catch (Exception e) {
      System.out.println(testSuiteID + "-Query_TimeStamp : FAIL");
      System.out.println("Exception Caught: " + e );
      status.addStatus(testSuiteID + "-Query_TimeStamp", status.FAIL);
     }

     try {
        Double result = dao.getAvgofShort();
        System.out.println(testSuiteID + "-Avgerage_ShortData : " + result);
	if(result==11256){
        status.addStatus(testSuiteID + "-Average_ShortData", status.PASS);
	} else status.addStatus(testSuiteID + "-Average_ShortData ", status.FAIL);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Average_ShortData : FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Average_ShortData", status.FAIL);
     }

     try {
        Double result = dao.getAvgofByte();
        System.out.println(testSuiteID + "-Avgerage_ByteData : " + result);
        if(result==76){
          status.addStatus(testSuiteID + "-Average_ByteData", status.PASS);
        } else status.addStatus(testSuiteID + "-Average_ByteData", status.FAIL);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Average_ByteData : FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Average_ByteData", status.FAIL);
     }

     try {
        Double result = dao.getAvgofLong();
        System.out.println(testSuiteID + "-Avgerage_LongData : " + result);
        // if(result==76){
        status.addStatus(testSuiteID + "-Average_LongData", status.PASS);
        // } else status.addStatus("-Average_LongData ", status.FAIL);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Average_LongData : FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Average_LongData", status.FAIL);
     }

     try {
        Double result = dao.getAvgofFloat();
        System.out.println(testSuiteID + "-Avgerage_FloatData : " + result);
        // if(result==76){
        status.addStatus(testSuiteID + "-Average_FloatData", status.PASS);
        // } else status.addStatus("-Average of FloatData test ", status.FAIL);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Average_FloatData : FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Average_FloatData", status.FAIL);
     }

     try {
        Double result = dao.getAvgofInteger();
        System.out.println(testSuiteID + "-Avgerage_IntegerData : " + result);
        if(result==1000){
          status.addStatus(testSuiteID + "-Average_IntegerData", status.PASS);
        } else status.addStatus(testSuiteID + "-Average_IntegerData ", status.FAIL);
     } catch (Exception e) {
        System.out.println(testSuiteID + "-Average_IntegerData : FAIL");
        System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Average_IntegerData", status.FAIL);
     }

     try {
     	dao.remove(secondrow);
     	List listLong1 = dao.whereWithLong(new Long("1002"));
     	System.out.println("The size of the second row after removed: " + listLong1.size());
      	System.out.println(testSuiteID + "-Delete_row: PASS");
        status.addStatus(testSuiteID + "-Delete_row", status.PASS);
     } catch (Exception e) {
      	System.out.println(testSuiteID + "-Delete_row: FAIL");
      	System.out.println("Exception Caught: " + e );
        status.addStatus(testSuiteID + "-Delete_row", status.FAIL);
     }
     status.printSummary(" EJB 3.0 DataTypes Tests: ");
   }
}
